/*
 * Copyright 2016 Sony Corporation
 */
#ifndef	__H_MODEL_COMMON_H__
#define	__H_MODEL_COMMON_H__

#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/miscdevice.h>
#include <mach/mt_gpio.h>
#include <cust_gpio_usage.h>

#ifndef		DRV_NAME
#error	"Macro DRV_NAME is not defined"
#endif

// debug print
#if	0
#define DBGTRACE(fmt, ...)		0
#define CHECKPOINT			0
#else
#define DBGTRACE(fmt, ...)		\
	printk("[" DRV_NAME "] "       fmt "\n", ## __VA_ARGS__)
#define CHECKPOINT			\
	printk("[" DRV_NAME "] %s %s %d\n", __FILE__, __func__, __LINE__)
#endif
#define DRVTRACE(fmt, drvnum, ...)	\
	printk("[" DRV_NAME " %02x] "  fmt "\n", drvnum, ## __VA_ARGS__)
#define ERRTRACE(fmt, ...)		\
	printk("[" DRV_NAME "] error " fmt " %s %d\n", ## __VA_ARGS__, __FILE__, __LINE__)

/*
 * sleep & reschedule kernel task
 *
 *  IN : jiffy        = time to wait (sec * HZ)
 *  OUT: none
 */
static inline void	my_jiffy_sleep(long sleep_jiffy)
{
	set_current_state(TASK_UNINTERRUPTIBLE);
	schedule_timeout(sleep_jiffy);
}

/*
 * sleep & reschedule kernel task
 *
 *  IN : msec        = time to wait (milli sec)
 *  OUT: none
 */
static inline void      my_msleep(long msec)
{
	long    wait;

	wait = msecs_to_jiffies(msec);
	if (wait <= 0)
		wait = 1L;
	my_jiffy_sleep(wait);
}

#endif	// __H_MODEL_COMMON_H__
